<template>
  <v-lazy :min-height="viewPort.maxHeight" style="height: 100%">
    <v-card
      class="mx-auto mb-3 d-flex flex-column border-accent"
      v-bind="viewPort"
      tile
      outlined
      min-height="100%"
      @mouseover="isHover = true"
      @mouseleave="isHover = false"
    >
      <!-- Title Card -->
      <v-list-item :class="{ 'shades--text shrink': true }" dense :ripple="false" @click="goToDetail">
        <!-- Property name and address -->
        <v-list-item-content class="pa-0">
          <v-list-item-title class="title font-weight-bold gray--text" v-text="value.name" />
          <v-list-item-subtitle class="caption gray--text" v-text="fullAddress" />
        </v-list-item-content>
        <!-- Actions -->
        <v-list-item-action style="position: relative" class="d-flex flex-row flex-nowrap">
          <v-tooltip bottom>
            <template v-slot:activator="{ on }">
              <v-btn
                icon
                :color="comparison.inList ? 'accent' : comparison.canAdd ? '' : 'grey ligten-4'"
                v-on="on"
                @click.capture.stop="comparison.toggle(value)"
              >
                <v-icon>
                  {{ comparison.icon }}
                </v-icon>
              </v-btn>
            </template>
            <span>{{ comparison.inList ? 'Remove from' : 'Add to' }} Comparison</span>
          </v-tooltip>
          <v-tooltip bottom>
            <template v-slot:activator="{ on }">
              <v-btn
                icon
                :color="favorite.inList ? 'accent' : favorite.canAdd ? '' : 'grey ligten-4'"
                v-on="on"
                @click.capture.stop="favorite.toggle(value)"
              >
                <v-icon>
                  {{ favorite.icon }}
                </v-icon>
              </v-btn>
            </template>
            <span>{{ favorite.inList ? 'Remove from' : 'Save to' }} Favorites</span>
          </v-tooltip>
        </v-list-item-action>
      </v-list-item>
      <!-- Details -->
      <v-row no-gutters class="grow">
        <v-col cols="12" :sm="vertical ? 12 : 6">
          <!-- Carousel images -->
          <v-carousel
            v-model="imagePosition"
            :show-arrows-on-hover="isDesktop"
            hide-delimiter-background
            hide-delimiters
            :height="viewPort.maxHeight - 70"
          >
            <v-carousel-item v-for="(photo, idx) in value.photos.slice(0, 5)" :key="idx">
              <v-img
                :src="photo.src"
                :height="viewPort.maxHeight - 70"
                :aspect-ratio="16/9"
                class="white--text align-end clickable"
                @click="goToDetail"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular indeterminate color="accent" />
                  </v-row>
                </template>
                <v-card-title
                  v-if="photo.description"
                  class="subtitle-1 py-1"
                  style="background: #00000060"
                  v-text="photo.description"
                />
              </v-img>
            </v-carousel-item>
          </v-carousel>
        </v-col>
        <!-- Content -->
        <v-col
          cols="12"
          :sm="vertical ? 12 : 6"
          class="px-2 d-flex grow clickable flex-column justify-space-between"
          @click="goToDetail"
        >
          <v-list dense class="grow ">
            <v-list-item v-for="idx in [0, 1, 2]" :key="idx" dense class="pa-0 shrink">
              <template v-if="summary[idx]">
                <v-list-item-content>
                  <v-list-item-title>{{ summary[idx].rooms }}</v-list-item-title>
                  <v-list-item-subtitle>{{ summary[idx].sizes }}</v-list-item-subtitle>
                </v-list-item-content>
                <v-list-item-content class="text-right">
                  <v-list-item-title>{{ summary[idx].prices }}</v-list-item-title>
                  <v-list-item-subtitle>{{ summary[idx].count }}</v-list-item-subtitle>
                </v-list-item-content>
              </template>
            </v-list-item>
          </v-list>
          <v-row class="shrink" dense>
            <v-col cols="6">
              <v-btn
                block
                small
                color="accent lighten-1 caption"
                outlined
                href="tel:+18008912311"
                @click.capture.stop
              >
                (800) 891-2311
              </v-btn>
            </v-col>
            <v-col cols="6">
              <v-btn
                block
                small
                color="accent lighten-1 caption"
                to="/hot-deals"
                depressed
                @click.capture.stop
              >
                <v-icon left size="20">
                  {{ mdiEmailEdit }}
                </v-icon>
                <span class="text-capitalize">hot deal</span>
              </v-btn>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-card>
  </v-lazy>
</template>

<script lang="ts">
import { mdiEmailEdit, mdiClose } from '@mdi/js'
import { defineComponent, onMounted, ref, onUnmounted, computed } from '@vue/composition-api'
import { IRentProperty } from 'apartments-shared'

import ContactForm from '@/components/ContactForm.vue'
import { useFavorite, useComparison } from '@/hooks/utils'
import { formatAvailable, formatFullAddress, formatSummary } from '@/utils'

export default defineComponent({
  name: 'PropertyCard',
  components: { ContactForm },
  props: {
    value: {
      type: Object as () => IRentProperty,
      required: true
    },
    vertical: {
      type: Boolean,
      default: false
    }
  },
  setup ({ value, vertical }, { root: { $router, $vuetify: { breakpoint } } }) {
    const goToDetail = () => {
      const { id } = value
      $router.push({ name: 'apartment-id', params: { id } })
    }
    const isDesktop = ref(true)
    const viewPort = computed(() => isDesktop.value && !vertical ? { maxHeight: 270 } : {})
    const imagePosition = ref(0)
    const isHover = ref(false)
    onMounted(() => {
      isDesktop.value = breakpoint?.smAndUp ?? true
    })
    const pressKeyCode = ({ keyCode }: KeyboardEvent) => {
      if (!isHover.value) { return }
      if (keyCode === 39 || keyCode === 37) {
        imagePosition.value += keyCode - 38
      }
    }
    onMounted(() => {
      if (process.client) {
        window.addEventListener('keyup', pressKeyCode)
      }
    })
    onUnmounted(() => {
      if (process.client) {
        window.removeEventListener('keyup', pressKeyCode)
      }
    })
    const comparison = useComparison(value.id)
    const favorite = useFavorite(value.id)
    const showBottomSheet = ref(false)
    return {
      goToDetail,
      imagePosition,
      viewPort,
      isHover,
      pressKeyCode,
      mdiClose,
      showBottomSheet,
      isDesktop,
      mdiEmailEdit,
      favorite,
      comparison,
      summary: formatSummary(value),
      available: formatAvailable(value),
      fullAddress: formatFullAddress(value)
    }
  }
})
</script>

<style>
.border-accent {
  border: 1px solid var(--v-accent-base) !important;
}
.clickable {
  cursor: pointer;
}
</style>
